// $Id: comsupp.cpp,v 1.2 2001/07/12 04:09:58 cthuang Exp $
//
// These functions are defined in comsupp.lib but Borland C++ does not include
// that library in its distribution, so we implement them here when compiling
// with Borland C++.
#include <stdlib.h>
#include <string.h>
#include <comdef.h>
#include <comutil.h>

// This value represents a missing optional parameter.
_variant_t vtMissing(DISP_E_PARAMNOTFOUND, VT_ERROR);

// COM error handling routine

void __stdcall
_com_issue_error (HRESULT hr) throw(_com_error)
{
    throw _com_error(hr);
}

namespace _com_util {

// Convert char * to BSTR

BSTR __stdcall
ConvertStringToBSTR (const char* pSrc) throw(_com_error)
{
    if (pSrc == 0) {
	return SysAllocString(0);
    }

    // Guess the number of wide characters needed.
    size_t destLen = strlen(pSrc) + 1;
    wchar_t *pDest = new wchar_t[destLen];
    mbstowcs(pDest, pSrc, destLen);
    BSTR result = SysAllocString(pDest);
    delete[] pDest;
    return result;
}

// Convert BSTR to char *

char* __stdcall
ConvertBSTRToString (BSTR pSrc) throw(_com_error)
{
    if (pSrc == 0) {
        char *pDest = new char[1];
	*pDest = '\0';
        return pDest;
    }

    // Guess the number of bytes needed.
    size_t destLen = wcslen(pSrc) * 3 + 1;
    char *pDest = new char[destLen];
    wcstombs(pDest, pSrc, destLen);
    return pDest;
}

} //namespace
